> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rated.network/llms.txt
> Use this file to discover all available pages before exploring further.

# Validator metadata [groups]

This endpoint allows users to request metadata for a group of validators that map to the same operator or pool (i.e. it gives you an answer to the question "give me all of Kiln's validator indices under Lido").

| Parameter           | Context                                                                                        |
| :------------------ | :--------------------------------------------------------------------------------------------- |
| `idType`            | The type of entity class you would like to filter by. You might ask for `pool`, `nodeOperator` |
| `operatorsIds`      | An array of entities names you want to filter by                                               |
| `from`              | The validator index you want to start to navigate from                                         |
| `size`              | The number of results included per page                                                        |
| `withdrawalAddress` | Filter by the withdrawal address                                                               |

<Note>
  Rated builds and operates the most complete dataset for validator id mappings. These are gated endpoints and is being provisioned on a case-by-case basis. If you're interested in working with it, get in touch via [hello@rated.network](mailto:hello@rated.network) with an overview of your use case.
</Note>


## OpenAPI

````yaml get /v0/eth/validators
openapi: 3.1.0
info:
  title: Rated API
  description: >

    Welcome to Rated API Swagger doc for developers! This doc outlines the Rated
    API functionality and API architecture.


    V0: It is separated into seven categories:


    -   **Validators**: Endpoints to query into individual validator indices or
    aggregations of validator indices.

    -   **Operators**: Endpoints to query into pre-materialized operator
    groupings.

    -   **Network**: Endpoints to query into network aggregate stats.

    -   **Slashings**: Endpoints to query into network aggregate stats.

    -   **Withdrawals (beta)**: Endpoints to query into when a withdrawal is
    expected to land.

    -   **Self Report (beta)**: Endpoint to query into all slashed validators
    and individual slashed validator indices


    V1: It is separated into six categories:

    -   **Overview**: Endpoints encapsulating the current status of operators,
    pools and validators.

    -   **Performance**: Endpoints that dive into performance and effectiveness
    metrics on execution and consensus layer for operators, pools and
    validators.

    -   **Rewards**: Endpoints that dive into relevant metrics around rewards
    and penalties for operators, pools and validators.

    -   **Private Sets**: Endpoints that aggregate custom group of validators
    privately for performance and reward drill downs.

    -   **Metadata**: Endpoints that provide metadata about mappings, slashings
    and APRs for validators, pools and operators.

    -   **Network**: Endpoints that provide network level metrics about
    performance, rewards, and distributions.


    [Terms of Use](https://docs.rated.network/legal/terms/api-terms-of-service)


    [API
    Reference](https://docs.rated.network/rated-api/api-reference/introduction)
  version: '1.0'
servers: []
security: []
paths:
  /v0/eth/validators:
    get:
      tags:
        - Validators
        - Validators
      summary: Get Metadata List
      operationId: get_metadata_list_v0_eth_validators_get
      parameters:
        - name: from
          in: query
          required: false
          schema:
            type: integer
            minimum: 0
            default: 0
            title: From
        - name: size
          in: query
          required: false
          schema:
            type: integer
            maximum: 200
            exclusiveMinimum: 0
            default: 100
            title: Size
        - name: operatorsIds
          in: query
          required: false
          schema:
            anyOf:
              - items:
                  type: string
                type: array
              - type: 'null'
            title: Operatorsids
        - name: withdrawalAddress
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: Withdrawaladdress
        - name: idType
          in: query
          required: false
          schema:
            anyOf:
              - $ref: '#/components/schemas/PoolOrNodeOperatorIdType'
              - type: 'null'
            default: nodeOperator
            title: Idtype
        - name: X-Rated-Network
          in: header
          required: false
          schema:
            $ref: '#/components/schemas/Network'
            default: mainnet
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedValidatorMetadata'
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Bad Request
      security:
        - HTTPBearer: []
components:
  schemas:
    PoolOrNodeOperatorIdType:
      type: string
      enum:
        - pool
        - nodeOperator
      title: PoolOrNodeOperatorIdType
    Network:
      type: string
      enum:
        - mainnet
        - hoodi
        - holesky
      title: Network
    PaginatedValidatorMetadata:
      properties:
        page:
          $ref: '#/components/schemas/api__schemas__page__Page'
        total:
          type: integer
          minimum: 0
          title: Total
        data:
          items:
            $ref: '#/components/schemas/ValidatorMetadata'
          type: array
          title: Data
        next:
          anyOf:
            - type: string
            - type: 'null'
          title: Next
      type: object
      required:
        - page
        - total
        - data
        - next
      title: PaginatedValidatorMetadata
      examples:
        - data:
            - activationEligibilityEpoch: 171000
              activationEpoch: 169000
              depositAddresses:
                - '0xc34eb7e3f34e54646d7cd140bb7c20a466b3e852'
              dvtNetwork: ''
              dvtOperators: []
              exitEpoch: 172000
              nodeOperators: []
              pool: ''
              subpool: ''
              validatorIndex: 1
              validatorPubkey: >-
                0xb44440543ceef8d77e065c70da15f7b731e56db5457571c465f025e032bbcd263a0990c8749b4ca6ff20d77004466666
              withdrawableEpoch: 172256
              withdrawalAddress: '0x0d369bb49efa5100fd3b86a9f828c55da04d2d50'
            - activationEligibilityEpoch: 171000
              activationEpoch: 169000
              depositAddresses:
                - '0xc34eb7e3f34e54646d7cd140bb7c20a466b3e852'
              dvtNetwork: ''
              dvtOperators: []
              exitEpoch: 172000
              nodeOperators: []
              pool: ''
              subpool: ''
              validatorIndex: 4
              validatorPubkey: >-
                0xa62420543ceef8d77e065c70da15f7b731e56db5457571c465f025e032bbcd263a0990c8749b4ca6ff20d77004454b51
              withdrawableEpoch: 172256
              withdrawalAddress: '0x0d369bb49efa5100fd3b86a9f828c55da04d2d50'
            - activationEligibilityEpoch: 171000
              activationEpoch: 169000
              depositAddresses:
                - '0xc34eb7e3f34e54646d7cd140bb7c20a466b3e852'
              dvtNetwork: ''
              dvtOperators: []
              exitEpoch: 172000
              nodeOperators: []
              pool: ''
              subpool: ''
              validatorIndex: 10
              validatorPubkey: >-
                0xc55540543ceef8dccc065c70da15f7b731e56db5457571c465f0254442bbcd263a0111c8749b4ca6ff20d77004466777
              withdrawableEpoch: 172256
              withdrawalAddress: '0x0d369bb49efa5100fd3b86a9f828c55da04d2d50'
          next: /v0/eth/validators?from=11&size=3&operatorsIds=&idType=
          page:
            from: 0
            size: 3
          total: 11
    ErrorResponse:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Error'
          type: array
          title: Detail
      type: object
      required:
        - detail
      title: ErrorResponse
    api__schemas__page__Page:
      properties:
        from:
          anyOf:
            - type: integer
            - type: string
              format: date
            - type: 'null'
          title: From
        to:
          anyOf:
            - type: integer
            - type: string
              format: date
            - type: 'null'
          title: To
        size:
          type: integer
          exclusiveMinimum: 0
          title: Size
          default: 10
        granularity:
          anyOf:
            - $ref: '#/components/schemas/GranularityEnum'
            - type: 'null'
        filterType:
          anyOf:
            - $ref: '#/components/schemas/FilterTypeEnum'
            - type: 'null'
      type: object
      title: Page
    ValidatorMetadata:
      properties:
        validatorIndex:
          type: integer
          minimum: 0
          title: Validatorindex
        validatorPubkey:
          type: string
          title: Validatorpubkey
        pool:
          anyOf:
            - type: string
            - type: 'null'
          title: Pool
        dvtNetwork:
          anyOf:
            - type: string
            - type: 'null'
          title: Dvtnetwork
        nodeOperators:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Nodeoperators
        depositAddresses:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Depositaddresses
        dvtOperators:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Dvtoperators
        activationEpoch:
          anyOf:
            - type: integer
            - type: 'null'
          title: Activationepoch
        activationEligibilityEpoch:
          anyOf:
            - type: integer
            - type: 'null'
          title: Activationeligibilityepoch
        exitEpoch:
          anyOf:
            - type: integer
            - type: 'null'
          title: Exitepoch
        withdrawableEpoch:
          anyOf:
            - type: integer
            - type: 'null'
          title: Withdrawableepoch
        withdrawalAddress:
          anyOf:
            - type: string
            - type: 'null'
          title: Withdrawaladdress
        subpool:
          anyOf:
            - type: string
            - type: 'null'
          title: Subpool
      type: object
      required:
        - validatorIndex
        - validatorPubkey
        - pool
        - dvtNetwork
        - nodeOperators
        - depositAddresses
        - dvtOperators
        - activationEpoch
        - activationEligibilityEpoch
        - exitEpoch
        - withdrawableEpoch
        - withdrawalAddress
        - subpool
      title: ValidatorMetadata
      examples:
        - activationEligibilityEpoch: 0
          activationEpoch: 0
          depositAddresses:
            - '0x74134d0c91798d720a5585364bb4be7396c5b973'
          dvtOperators: []
          nodeOperators: []
          validatorIndex: 100
          validatorPubkey: >-
            0xb5bc96b70df0dfcc252c9ff0d1b42cb6dc0d55f8defa474dc0a5c7e0402c241e2850fea9c582e276b638b3c2c3a5ec55
          withdrawalAddress: '0xfff1ce616cf83327981bf61396ad0c04e0c8b771'
    Error:
      properties:
        loc:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Loc
        msg:
          type: string
          title: Msg
        type:
          type: string
          title: Type
      type: object
      required:
        - msg
        - type
      title: Error
    GranularityEnum:
      type: string
      enum:
        - hour
        - day
        - week
        - month
        - quarter
        - year
        - all
      title: GranularityEnum
    FilterTypeEnum:
      type: string
      enum:
        - hour
        - day
        - datetime
      title: FilterTypeEnum
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````